

FeatMonitor_allClear = {}
FeatMonitor_allClear.new = function ( params )
	
	local this = {}
	this.className = "FeatMonitor_allClear"
	this.params = paramas
	
	this.featId = "allClear"
	this.featName = "全ステージクリア"
	this.description = "STORY MODE の全"..stage_last.."ステージをクリア。"
	
	this.currentPhase = ""
	this.prevPhase = ""
	
	this.prevStage = 0
	
	this.isAchieved = false
	
	--=========================================================
	-- 更新
	--=========================================================
	this.update = function (self)
		
		if ( self.isAchieved ) then
			return
		end
		
		self.prevPhase = self.currentPhase
		self.currentPhase = phase
		
		-- ストーリーデモからタイトルに戻ってきて、ステージが5だったなら、
		if ( self.prevPhase == "storyDemo" and self.currentPhase == "title" and self.prevStage >= stage_last ) then
			self.isAchieved = true
			setFeatAchievedMessage ( self )
		end

		self.prevStage = stage
		
	end
	

	
	return this
end
 

