

FeatMonitor_allClear_noMiss = {}
FeatMonitor_allClear_noMiss.new = function ( params )
	
	local this = {}
	this.className = "FeatMonitor_allClear_noMiss"
	this.params = paramas
	
	this.featId = "allClear_noMiss"
	this.featName = "ノーミスクリア"
	this.description = "STORY MODE の全"..stage_last.."ステージを残機を失わずにクリア。"
	
	this.currentPhase = ""
	this.prevPhase = ""
	
	this.currentLeft = 0
	this.prevLeft    = 0
	this.isNomiss = true

	this.prevStage = 0
	
	this.isAchieved = false

	--=========================================================
	-- 条件フラグリセット
	--=========================================================
	this.reset = function (self)
		self.currentPhase = ""
		self.prevPhase = ""
		
		self.currentLeft = 0
		self.prevLeft    = 0
		self.isNomiss = true
	end
	
	--=========================================================
	-- 更新
	--=========================================================
	this.update = function (self)
		
		if ( self.isAchieved ) then
			return
		end
		
		self.prevPhase = self.currentPhase
		self.currentPhase = phase
		
		self.prevLeft = self.currentLeft
		self.currentLeft = #left
--		self.currentLeft = left
		
		if ( self.currentLeft < self.prevLeft ) then
			self.isNomiss = false
		end
		
		-- タイトル画面で、直前のステージが5なら、クリアしたと判定
		if ( self.isNomiss ) then

			-- ストーリーデモからタイトルに戻ってきて、ステージが5だったなら、
			if ( self.prevPhase == "storyDemo" and self.currentPhase == "title" and self.prevStage >= stage_last ) then
				self.isAchieved = true
				setFeatAchievedMessage ( self )
			end
			
			self.prevStage = stage
		end

		
	end
	

	
	return this
end
 

