

Left = {}
Left.new = function ( params )
	
	local this = {}
	this.className = "Left"
	this.params = paramas
	
	this.energyExtra = 0

	--=========================================================
	-- 余剰エネルギー追加
	--=========================================================
	this.addEnergy = function (self, energy)
		
		local energyExtraMax = energyMaxInit - energyInit
		local over = 0
		
		self.energyExtra = self.energyExtra + energy
		if ( self.energyExtra > energyExtraMax ) then
			over = self.energyExtra - energyExtraMax
			self.energyExtra = energyExtraMax
		end
		
		return over
	end
	
	--=========================================================
	-- 描画
	--=========================================================
	this.draw = function (self, x, y)
	
		local r,g,b,a = love.graphics.getColor()
		
		love.graphics.setColor ( 1,1,1,1 )
		
		love.graphics.draw ( spriteSheet, spriteQuad_pcMachine, x, y )
		
		if ( self.energyExtra > 0 ) then
		
			local r = 5
			local energyExtraMax = energyMaxInit - energyInit
			local energyExtraAngle = self.energyExtra / energyExtraMax * 360
			local energyX = x + 5
			local energyY = y + 5
			
			love.graphics.setColor ( 0, 1, 0, 1 )
			love.graphics.arc("fill", "pie", energyX, energyY, r, math.rad(-90), math.rad(-90 + energyExtraAngle))

			love.graphics.setColor ( 1,1,1,1 )
			love.graphics.circle ( "line", energyX, energyY, 5 )
		end



		love.graphics.setColor ( r,g,b,a )
	end
	
	return this
end
 

