--=========================================================
--
-- 未知
--
--=========================================================
Unknown = {}
Unknown.new = function ( params )
	
	local this = {}
	this.className = "Unknown"
	this.params = paramas
	
	this.spriteQuads = {}
	this.spriteQuads [#this.spriteQuads + 1] = love.graphics.newQuad ( 1 * SPRITE_WIDTH, 2 * SPRITE_HEIGHT, SPRITE_WIDTH, SPRITE_HEIGHT, spriteSheet:getDimensions() )
	this.spriteQuads [#this.spriteQuads + 1] = love.graphics.newQuad ( 0 * SPRITE_WIDTH, 2 * SPRITE_HEIGHT, SPRITE_WIDTH, SPRITE_HEIGHT, spriteSheet:getDimensions() )
	this.spriteQuads [#this.spriteQuads + 1] = love.graphics.newQuad ( 2 * SPRITE_WIDTH, 2 * SPRITE_HEIGHT, SPRITE_WIDTH, SPRITE_HEIGHT, spriteSheet:getDimensions() )
	this.spriteQuads [#this.spriteQuads + 1] = love.graphics.newQuad ( 0 * SPRITE_WIDTH, 2 * SPRITE_HEIGHT, SPRITE_WIDTH, SPRITE_HEIGHT, spriteSheet:getDimensions() )
	
	this.animationWaitMax = 3
	this.animationWait    = this.animationWaitMax
	this.animationCount   = 1
	
	this.x = 0
	this.y = 0
	this.speed = 5
	
--	this.hitSize = 10
--	this.hitSize = 15
	this.hitSize = 16
	this.hitOffsetX = 0
	this.hitOffsetY = 0
	
	this.type = "A"
	
	this.isLeaving = false
	this.leavingAnimationCount = 0
	this.isEnd = false
	
	--=========================================================
	-- 初期設定
	--=========================================================
	this.init = function (self)
		
		--local left_right = math.random(100)
		--local type       = math.random(100)
		local left_right = crand_forLR:get()
		local type       = crand_forAB:get()
		local y          = math.random(10, canvas_field:getHeight()/3)
		--local y          = math.random(50, canvas_field:getHeight()/3)
		
		--if ( type < 50 ) then
		--if ( type_lot[type_currentLotIndex] == 0 ) then
		if ( type == 1 ) then
			self.type = "A"
		else
			self.type = "B"
		end
		
		--type_currentLotIndex = type_currentLotIndex + 1
		--if ( type_currentLotIndex > #type_lot ) then type_currentLotIndex = 1 end
		
		--if ( left_right < 50 ) then
		if ( left_right == 1 ) then
			
			self.x = -1 * SPRITE_WIDTH
			self.y = y
			self.speed = 3
			
		else
			
			self.x = canvas_field:getWidth() + SPRITE_WIDTH
			self.y = y
			self.speed = -3
		end
		--print(self.x, self.y, self.type, self.speed)
	end
	
	--=========================================================
	-- おにぎりを受け取って、「お礼」を出す
	--=========================================================
	this.recieveGoodWill = function (self, goodWill)
		
--[[		
		local reactionType = self.type
		local reactNum = 4
		for i = 1, reactNum, 1 do
			
			local angle = crand_forResAngle:get()
--			addReaction ( self.x, self.y, math.rad ( math.random(180) ), reactionType )
			addReaction ( self.x, self.y, math.rad ( angle ), reactionType )
		end		
		
		--local reactNum = math.pow(2, consecution-1)  --5
]]--

		local reactionType = self.type


		local reactNum = consecution * 2
		
		local reactionSoundId = "reaction"
		
		if ( goodWill.duration > 50 ) then
			reactNum = reactNum * 7
			reactionSoundId = "reaction3"
			print ("遠距離 x7")

			reactionType = "A"
			
		elseif ( goodWill.duration > 30 ) then
			reactNum = reactNum * 2
			reactionSoundId = "reaction2"
			print ("遠距離 x2")
		end

		playSound ( sounds[reactionSoundId] )

		

		-- 赤が連続する場合の理不尽感リリーフ
		if ( reactionType == "B") then
			reactionBconsecution = reactionBconsecution + 1
			if ( reactionBconsecution > reactionBconsecutionLimit ) then
				reactionType = "A"
				reactionBconsecution = 0
				print("理不尽リリーフにより調整")
			end
		else
			reactionBconsecution = 0
		end
		
		for i = 1, reactNum, 1 do

--			local angle = crand_forResAngle:get()
--			addReaction ( self.x, self.y, math.rad ( angle ), reactionType )

			if ( goodWill.isTutorial ) then
				local angle = 45 + i/(reactNum+1) * 90
				addReaction ( self.x, self.y, math.rad ( angle ), reactionType )
			else
				local angle = crand_forResAngle:get()
	--			addReaction ( self.x, self.y, math.rad ( math.random(180) ), reactionType )
				addReaction ( self.x, self.y, math.rad ( angle ), reactionType )
			end
		end

		-- 50回以降、25回ごとに1up出現
		numOfDeliveries = numOfDeliveries + 1
		if ( numOfDeliveries >= 50 ) then
			if ( numOfDeliveries%25 == 0 ) then
				--addItem("extend")
				
				--  → じゃなくて、大型出現とする
				addUnknown_big(1)
			end
		end
		
		self.isLeaving = true

	end
	
	--=========================================================
	-- 更新
	--=========================================================
	this.update = function (self)
		
		if ( self.isEnd ) then
			return
		end
		
		-- 退去中
		if ( self.isLeaving ) then
			
			local leaveDirection = -1
			if ( self.x > canvas_field:getWidth()/2 ) then
				leaveDirection = 1
			end
			
			self.x = self.x + math.abs(self.speed) * 1.5 * leaveDirection
			self.leavingAnimationCount = self.leavingAnimationCount + 1
			
			if ( self.x < -1 * SPRITE_WIDTH/2 or self.x > canvas_field:getWidth() + SPRITE_WIDTH/2 ) then
				self.isEnd = true
			end
			
		else
			
			if ( self.animationWait <= 0 ) then
				self.animationWait = self.animationWaitMax
				
				self.animationCount = self.animationCount + 1
				if ( self.animationCount > #self.spriteQuads ) then
					self.animationCount = 1
				end
			
			else
				self.animationWait = self.animationWait - 1
			end
			
			
			self.x = self.x + self.speed
			if ( self.x < -1 * SPRITE_WIDTH or self.x > canvas_field:getWidth() + SPRITE_WIDTH ) then
				self.isEnd = true
			end
			
			-- 自機との当たり判定
			if ( not playerMachine.isCrashing and playerMachine.blownoffCount <= 0 and playerMachine.blinkCount <= 0 ) then -- 連続で当たるのも悪くないかも

				local distToPlayer = utils.getDistance ( 
					self.x + self.hitOffsetX, self.y + self.hitOffsetY, 
					playerMachine.x + playerMachine.hitOffsetX, playerMachine.y + playerMachine.hitOffsetY ) 
				
				if ( distToPlayer < ( playerMachine.hitSize + self.hitSize ) ) then
					
					--[[
					if ( self.type == "A" ) then
						playerMachine:gain(10)
					elseif ( self.type == "B" ) then
						playerMachine:lose(10)
					end
					
					self.isLeaving = true
					]]--
					playerMachine:blownoff(self)
					
				end
			end
		end
		
	end
	
	--=========================================================
	-- 描画
	--=========================================================
	this.draw = function (self)
	
		if ( self.isEnd ) then
			return
		end
		
		local r,g,b,a = love.graphics.getColor()
		
		local color = colors["Unknown"]
		
		if ( self.isLeaving ) then
			if ( self.leavingAnimationCount%5 <= 2 ) then
				color = colors [ self.type ]
			else
				color = colors [ "White" ]
			end
		end
		
		love.graphics.setColor ( color.r, color.g, color.b, color.a )
		
		local drawX = self.x - SPRITE_WIDTH/2
		local drawY = self.y - SPRITE_HEIGHT/2
		
		local quad = self.spriteQuads [ self.animationCount ]
		
		love.graphics.draw ( spriteSheet, quad, drawX, drawY )
		
		if ( isHitAreaShown ) then
			love.graphics.setColor ( 1,0,0,1 )
			love.graphics.circle ( "line", self.x + self.hitOffsetX, self.y + self.hitOffsetY, self.hitSize )
		end
		
		love.graphics.setColor ( r,g,b,a )
	end
	
	return this
end
 

