

FeatMonitor_test = {}
FeatMonitor_test.new = function ( params )
	
	local this = {}
	this.className = "FeatMonitor_test"
	this.params = paramas
	
	this.featId = "test"
	this.featName = "テスト"
	this.description = "実験。おにぎり一発射出したら達成。"
	
	this.isAchieved = false
	
	--=========================================================
	-- 更新
	--=========================================================
	this.update = function (self)
		
		if ( self.isAchieved ) then
			return
		end
		
		if ( #goodWills >= 1  ) then
			self.isAchieved = true
			setFeatAchievedMessage ( self )
		end
		
		
	end
	
	--=========================================================
	-- 描画
	--=========================================================
	this.draw = function (self, x, y)
	
		local r,g,b,a = love.graphics.getColor()
		local currentFont = love.graphics.getFont()
		local currentLineWidth  = love.graphics.getLineWidth()
		
		local font = fonts.default
		love.graphics.setFont(font)
		love.graphics.setLineWidth(2)
		local cornerRound = 5
		
		love.graphics.setColor ( 0,0,0,1 )
		love.graphics.rectangle( "fill", x, y, self.width, self.height, cornerRound)
		love.graphics.setColor ( 1,1,1,1 )
		love.graphics.rectangle( "line", x, y, self.width, self.height, cornerRound)
		
		love.graphics.print ( self.featName, x + 5, y + 5 )

		love.graphics.setLineWidth(currentLineWidth)
		love.graphics.setFont(currentFont)
		love.graphics.setColor ( r,g,b,a )
	end
	
	return this
end
 

