
local scripts = {}


scripts["storyDemoOP1"] = {
	
	{ frame = 1, procName = "registFont", id = "default", file = "PixelMplus10-Regular.ttf", size = 20},

	{ frame = 1, procName = "registSound", id = "opening"},
	{ frame = 1, procName = "sound_play", id = "opening"},
	{ frame = 1, procName = "sound_setLoop", id = "opening"},
	
	{ frame = 1, procName = "registImage", id = "deepSpace", file = "universe.png"},
	{ frame = 1, procName = "registImage", id = "unknownAfar1", file = "unknown_afar1.png"},
	{ frame = 1, procName = "registImage", id = "unknownAfar2", file = "unknown_afar2.png"},
	{ frame = 1, procName = "registImage", id = "unknownAfar3", file = "unknown_afar3.png"},

	{ frame = 1, procName = "registImage", id = "frame",     file = "frame.png"},

	{ frame = 1, procName = "image_show", id = "deepSpace"},
	{ frame = 1, procName = "image_show", id = "frame"},
	
	{ frame = 1, procName = "image_setPosition", id = "deepSpace", x = 400, y = 400},
	{ frame = 1, procName = "image_move",        id = "deepSpace", toX = 400, toY = 200, speed = 1},
	
	{ frame = 201, procName = "image_setPosition", id = "unknownAfar1", x = 180, y = 100},
	{ frame = 201, procName = "image_show", id = "unknownAfar1"},
	{ frame = 201, procName = "image_move", id = "unknownAfar1", toX = 620, toY = 200, speed = 3},
	
	{ frame = 401, procName = "image_setPosition", id = "unknownAfar2", x = 620, y = 200},
	{ frame = 401, procName = "image_show", id = "unknownAfar2"},
	{ frame = 401, procName = "image_move", id = "unknownAfar2", toX = 180, toY = 300, speed = 3},
	
	{ frame = 601, procName = "image_setPosition", id = "unknownAfar3", x = 180, y = 300},
	{ frame = 601, procName = "image_show", id = "unknownAfar3"},
	{ frame = 601, procName = "image_move", id = "unknownAfar3", toX = 620, toY = 400, speed = 3},
	

	{ frame = 1, procName = "registText", id = "speak1", fontId = "default", lineLength = 20, text = "遥か宇宙の深淵……"},
	{ frame = 1, procName = "registText", id = "speak2", fontId = "default", lineLength = 20, text = "太陽系外から地球への未確認生命体の接近が確認された。"},
	{ frame = 1, procName = "registText", id = "speak3", fontId = "default", lineLength = 20, text = "彼らの目的は不明である。"},
	{ frame = 1, procName = "registText", id = "speak4", fontId = "default", lineLength = 20, text = "だが恒星間航行を成し遂げている彼らが、科学力で人類を圧倒していることは確実だった。"},
	{ frame = 1, procName = "text_setPosition", id = "speak1", x = 200, y = 430},
	{ frame = 1, procName = "text_setPosition", id = "speak2", x = 200, y = 430},
	{ frame = 1, procName = "text_setPosition", id = "speak3", x = 200, y = 430},
	{ frame = 1, procName = "text_setPosition", id = "speak4", x = 200, y = 430},
	{ frame = 1, procName = "text_setDisplayWait", id = "speak1", displayWait = 3},
	{ frame = 1, procName = "text_setDisplayWait", id = "speak2", displayWait = 3},
	{ frame = 1, procName = "text_setDisplayWait", id = "speak3", displayWait = 3},
	{ frame = 1, procName = "text_setDisplayWait", id = "speak4", displayWait = 3},
	
	{ frame =  10, procName = "text_show", id = "speak1"},
	{ frame =  150, procName = "text_hide", id = "speak1"},
	{ frame =  200, procName = "text_show", id = "speak2"},
	{ frame =  400, procName = "text_hide", id = "speak2"},
	{ frame =  410, procName = "text_show", id = "speak3"},
	{ frame =  600, procName = "text_hide", id = "speak3"},
	{ frame =  610, procName = "text_show", id = "speak4"},
	{ frame =  900, procName = "text_hide", id = "speak4"},
	
	{ frame =  950, procName = "nextPage", scriptName = "storyDemoOP2"},
	
}


scripts["storyDemoOP2"] = {
	
	{ frame = 1, procName = "registFont", id = "default", file = "PixelMplus10-Regular.ttf", size = 20},

	{ frame = 1, procName = "registImage", id = "city", file = "city.png"},
	{ frame = 1, procName = "registImage", id = "fist_r1", file = "fist.png"},
	{ frame = 1, procName = "registImage", id = "fist_r2", file = "fist.png"},
	{ frame = 1, procName = "registImage", id = "fist_r3", file = "fist.png"},
	{ frame = 1, procName = "registImage", id = "fist_l1", file = "fist.png"},
	{ frame = 1, procName = "registImage", id = "fist_l2", file = "fist.png"},
	{ frame = 1, procName = "registImage", id = "fist_l3", file = "fist.png"},
	{ frame = 1, procName = "registImage", id = "frame", file = "frame.png"},
	
	{ frame = 1, procName = "registImage", id = "devided1", file = "devided1.png"},
	{ frame = 1, procName = "registImage", id = "devided2", file = "devided2.png"},
	{ frame = 1, procName = "registImage", id = "devided2_1", file = "devided2_1.png"},
	{ frame = 1, procName = "registImage", id = "devided2_2", file = "devided2_2.png"},
	{ frame = 1, procName = "registImage", id = "devided2_3", file = "devided2_3.png"},

	{ frame = 1, procName = "image_show", id = "city"},
	{ frame = 1, procName = "image_show", id = "frame"},
	
	{ frame = 1, procName = "text_setDefaultSettings", x = 200, y=430, displayWait = 1, lineLength=20, fontId="default"},
	
	{ frame = 1, text = "人々は計り知れない未知の力に恐れおののいた。", procName = "registText", id = "speak1"},
	{ frame = 1, text = "彼らの接近にどう対処すべきか？"              , procName = "registText", id = "speak2"},
--	{ frame = 1, text = "排除か？ 宥和か？", procName = "registText", id = "speak3"},
--	{ frame = 1, text = "人類は強硬派と穏健派に真っ二つに分断された。", procName = "registText", id = "speak3"},
	{ frame = 1, text = "排除か？ 宥和か？\n対応を巡り、人類は真っ二つに分断された。", procName = "registText", id = "speak3"},
	{ frame = 1, text = "恐怖に突き動かされた意見の対立は互いに一歩も譲ることなく、文字通りの戦いへと発展。", procName = "registText", id = "speak4"},
	{ frame = 1, text = "地球全土で十数年に及ぶ血みどろの闘争が繰り広げられ……", procName = "registText", id = "speak5"},
	{ frame = 1, text = "決着がつかないまま、文明は荒廃の一途を辿った。"     , procName = "registText", id = "speak6"},

	{ frame =   5, procName = "text_show", id = "speak1"},
	{ frame = 100, procName = "text_hide", id = "speak1"},
	{ frame = 120, procName = "text_show", id = "speak2"},
	{ frame = 200, procName = "text_hide", id = "speak2"},
	{ frame = 220, procName = "text_show", id = "speak3"},
	{ frame = 400, procName = "text_hide", id = "speak3"},
	{ frame = 410, procName = "text_show", id = "speak4"},
	{ frame = 580, procName = "text_hide", id = "speak4"},
	{ frame = 600, procName = "text_show", id = "speak5"},
	{ frame = 720, procName = "text_hide", id = "speak5"},
	{ frame = 740, procName = "text_show", id = "speak6"},
	{ frame = 960, procName = "text_hide", id = "speak6"},
	
	
	
	{ frame = 200, procName = "image_setPosition", id = "fist_r1", x = 520, y=520},
	{ frame = 200, procName = "image_setAngle",    id = "fist_r1", angle = -20},
	{ frame = 200, procName = "image_show", id = "fist_r1"},
	{ frame = 200, procName = "image_move", id = "fist_r1", toX = 480, toY=350, speed = 4},
	
	{ frame = 220, procName = "image_setPosition", id = "fist_r2", x = 595, y=520},
	{ frame = 220, procName = "image_setAngle",    id = "fist_r2", angle = -20},
	{ frame = 220, procName = "image_show", id = "fist_r2"},
	{ frame = 220, procName = "image_move", id = "fist_r2", toX = 555, toY=350, speed = 4},

	{ frame = 240, procName = "image_setPosition", id = "fist_r3", x = 640, y=420},
	{ frame = 240, procName = "image_setAngle",    id = "fist_r3", angle = -20},
	{ frame = 240, procName = "image_show", id = "fist_r3"},
	{ frame = 240, procName = "image_move", id = "fist_r3", toX = 600, toY=250, speed = 4},

	{ frame = 210, procName = "image_setScale",    id = "fist_l1", scaleW = -1, scaleH = 1},
	{ frame = 210, procName = "image_setPosition", id = "fist_l1", x = 300, y=520},
	{ frame = 210, procName = "image_setAngle",    id = "fist_l1", angle = 20},
	{ frame = 210, procName = "image_show", id = "fist_l1"},
	{ frame = 210, procName = "image_move", id = "fist_l1", toX = 320, toY=350, speed = 4},

	{ frame = 230, procName = "image_setScale",    id = "fist_l2", scaleW = -1, scaleH = 1},
	{ frame = 230, procName = "image_setPosition", id = "fist_l2", x = 205, y=520},
	{ frame = 230, procName = "image_setAngle",    id = "fist_l2", angle = 20},
	{ frame = 230, procName = "image_show", id = "fist_l2"},
	{ frame = 230, procName = "image_move", id = "fist_l2", toX = 245, toY=350, speed = 4},

	{ frame = 250, procName = "image_setScale",    id = "fist_l3", scaleW = -1, scaleH = 1},
	{ frame = 250, procName = "image_setPosition", id = "fist_l3", x = 160, y=420},
	{ frame = 250, procName = "image_setAngle",    id = "fist_l3", angle = 20},
	{ frame = 250, procName = "image_show", id = "fist_l3"},
	{ frame = 250, procName = "image_move", id = "fist_l3", toX = 200, toY=250, speed = 4},

	{ frame = 350, procName = "image_setShake", id = "fist_r1", shake = 5},
	{ frame = 350, procName = "image_setShake", id = "fist_r2", shake = 5},
	{ frame = 350, procName = "image_setShake", id = "fist_r3", shake = 5},
	{ frame = 350, procName = "image_setShake", id = "fist_l1", shake = 5},
	{ frame = 350, procName = "image_setShake", id = "fist_l2", shake = 5},
	{ frame = 350, procName = "image_setShake", id = "fist_l3", shake = 5},

	{ frame = 550, procName = "image_setShake", id = "fist_r1", shake = 5},
	{ frame = 550, procName = "image_setShake", id = "fist_r2", shake = 5},
	{ frame = 550, procName = "image_setShake", id = "fist_r3", shake = 5},
	{ frame = 550, procName = "image_setShake", id = "fist_l1", shake = 5},
	{ frame = 550, procName = "image_setShake", id = "fist_l2", shake = 5},
	{ frame = 550, procName = "image_setShake", id = "fist_l3", shake = 5},

	{ frame = 550, procName = "image_show", id = "devided1"},
	{ frame = 600, procName = "image_show", id = "devided2"},
	{ frame = 620, procName = "image_show", id = "devided2_1"},
	{ frame = 650, procName = "image_show", id = "devided2_2"},
	{ frame = 680, procName = "image_show", id = "devided2_3"},
	
	{ frame =  900, procName = "nextPage", scriptName = "storyDemoOP3"},
}

scripts["storyDemoOP3"] = {
	
	{ frame = 1, procName = "registFont", id = "default", file = "PixelMplus10-Regular.ttf", size = 20},
	
	{ frame = 1, procName = "text_setDefaultSettings", x = 200, y=430, displayWait = 1, lineLength=20, fontId="default"},
	
	{ frame = 1, text = "地球人同士が争っている間にも未確認生命体の接近は止むことはなく……", procName = "registText", id = "speak1"},
	{ frame = 1, text = "遭遇の瞬間は刻一刻と迫っていた。", procName = "registText", id = "speak2"},
	
	{ frame =   1, procName = "text_show", id = "speak1"},
	{ frame = 200, procName = "text_hide", id = "speak1"},
	{ frame = 210, procName = "text_show", id = "speak2"},
	{ frame = 400, procName = "text_hide", id = "speak2"},
	
	{ frame = 1, procName = "registImage", id = "deepSpace", file = "universe.png"},
	{ frame = 1, procName = "registImage", id = "earth", file = "earth.png"},
	{ frame = 1, procName = "registImage", id = "unknownAfar3", file = "unknown_afar3.png"},
	{ frame = 1, procName = "registImage", id = "frame",     file = "frame.png"},
	
	{ frame = 1, procName = "image_setPosition", id = "earth", x = 650, y = 450},
	{ frame = 1, procName = "image_setPosition", id = "unknownAfar3", x = 180, y = 300},

	{ frame = 1, procName = "image_show", id = "deepSpace"},
	{ frame = 1, procName = "image_show", id = "earth"},
	{ frame = 1, procName = "image_show", id = "unknownAfar3"},
	{ frame = 1, procName = "image_show", id = "frame"},

	{ frame =   1, procName = "image_move", id = "deepSpace",    toX = 200, toY = 200, speed = 0.5},
	{ frame =  10, procName = "image_move", id = "unknownAfar3", toX = 300, toY = 310, speed = 0.2},
	{ frame = 100, procName = "image_move", id = "earth",        toX = 500, toY = 350, speed = 0.5},
	
	{ frame =  380, procName = "nextPage", scriptName = "storyDemoOP4"},

}

scripts["storyDemoOP4"] = {
	
	{ frame = 1, procName = "registFont", id = "default", file = "PixelMplus10-Regular.ttf", size = 20},

	{ frame = 1, procName = "text_setDefaultSettings", x = 200, y=430, displayWait = 1, lineLength=20, fontId="default"},
	
	{ frame = 1, text = "切迫と絶望が人類の心に重くのしかかった。", procName = "registText", id = "speak1"},
	{ frame = 1, text = "彼らの接近にどう対処すべきか？", procName = "registText", id = "speak2"},
	{ frame = 1, text = "もはや答えを巡って争うには、資源も時間も無くなっていた。", procName = "registText", id = "speak3"},
	{ frame = 1, procName = "registImage", id = "city", file = "city.png"},
	{ frame = 1, procName = "registImage", id = "city_dark", file = "city_dark.png"},
	{ frame = 1, procName = "registImage", id = "city_darker", file = "city_darker.png"},

	{ frame = 1, procName = "image_show", id = "city"},
	{ frame = 50, procName = "image_hide", id = "city"},
	{ frame = 50, procName = "image_show", id = "city_dark"},
	{ frame = 100, procName = "image_hide", id = "city_dark"},
	{ frame = 100, procName = "image_show", id = "city_darker"},
	
	{ frame =   1, procName = "text_show", id = "speak1"},
	{ frame = 120, procName = "text_hide", id = "speak1"},
	{ frame = 130, procName = "text_show", id = "speak2"},
	{ frame = 270, procName = "text_hide", id = "speak2"},
	{ frame = 280, procName = "text_show", id = "speak3"},
	{ frame = 450, procName = "text_hide", id = "speak3"},

	{ frame =  460, procName = "nextPage", scriptName = "storyDemoOP5"},
}

scripts["storyDemoOP5"] = {
	
	{ frame = 1, procName = "registFont", id = "default", file = "PixelMplus10-Regular.ttf", size = 20},
	{ frame = 1, procName = "registFont", id = "big", file = "PixelMplus12-Regular.ttf", size = 100},

	{ frame = 1, procName = "text_setDefaultSettings", x = 200, y=430, displayWait = 1, lineLength=20, fontId="default"},

	{ frame = 1, text = "そんな中、人類が出した答えは……", procName = "registText", id = "speak1"},
	{ frame = 1, text = "善 意", procName = "registText", id = "speak2", fontId = "big"},
	{ frame = 1, text = "ただ全力の善意をもって、未知の生命体を迎えること。", procName = "registText", id = "speak3"},
	{ frame = 1, text = "それが人類が最終的に出した答えだった。", procName = "registText", id = "speak4"},
	
	{ frame = 1, procName = "text_setDisplayWait", id = "speak2", displayWait = 15},
	{ frame = 1, procName = "text_setPosition",    id = "speak2", x = 280, y = 230},

	{ frame =   1, procName = "text_show", id = "speak1"},
	{ frame = 120, procName = "text_hide", id = "speak1"},
	
	{ frame = 130, procName = "text_show", id = "speak2"},

	{ frame = 200, procName = "text_show", id = "speak3"},
	{ frame = 350, procName = "text_hide", id = "speak3"},
	{ frame = 360, procName = "text_show", id = "speak4"},
	{ frame = 530, procName = "text_hide", id = "speak4"},
	{ frame = 530, procName = "text_hide", id = "speak2"},
	
	{ frame =  460, procName = "nextPage", scriptName = "storyDemoOP6"},

}


scripts["storyDemoOP6"] = {
	
	{ frame = 1, procName = "registFont", id = "default", file = "PixelMplus10-Regular.ttf", size = 20},
	{ frame = 1, procName = "text_setDefaultSettings", x = 200, y=430, displayWait = 1, lineLength=20, fontId="default"},

	{ frame = 1, procName = "registImage", id = "onigiri", file = "onigiri.png"},
	{ frame = 1, procName = "registImage", id = "onigiri_light1", file = "onigiri_light1.png"},
	{ frame = 1, procName = "registImage", id = "onigiri_light2", file = "onigiri_light2.png"},
	{ frame = 1, procName = "registImage", id = "onigiri_light3", file = "onigiri_light3.png"},
	{ frame = 1, procName = "registImage", id = "onigiri_reflect1", file = "onigiri_reflect1.png"},
	{ frame = 1, procName = "registImage", id = "onigiri_reflect2", file = "onigiri_reflect2.png"},
	{ frame = 1, procName = "registImage", id = "onigiri_reflect3", file = "onigiri_reflect3.png"},

	{ frame = 1, procName = "image_setPosition", id = "onigiri_reflect1", x = 325, y = 300},
	{ frame = 1, procName = "image_setPosition", id = "onigiri_reflect2", x = 325, y = 300},
	{ frame = 1, procName = "image_setPosition", id = "onigiri_reflect3", x = 325, y = 300},
	{ frame = 1, procName = "image_setScale", id = "onigiri_reflect1", scaleW = 2.0, scaleH = 2.0},
	{ frame = 1, procName = "image_setScale", id = "onigiri_reflect2", scaleW = 2.0, scaleH = 2.0},
	{ frame = 1, procName = "image_setScale", id = "onigiri_reflect3", scaleW = 2.0, scaleH = 2.0},


	{ frame = 1, procName = "image_show", id = "onigiri"},
	{ frame = 1, procName = "image_setBrightness", id = "onigiri", brightness = 0.1},
	{ frame = 10, procName = "image_setBrightness", id = "onigiri", brightness = 0.2},
	{ frame = 20, procName = "image_setBrightness", id = "onigiri", brightness = 0.3},
	{ frame = 30, procName = "image_setBrightness", id = "onigiri", brightness = 0.4},
	{ frame = 40, procName = "image_setBrightness", id = "onigiri", brightness = 0.5},
	{ frame = 50, procName = "image_setBrightness", id = "onigiri", brightness = 0.6},
	{ frame = 60, procName = "image_setBrightness", id = "onigiri", brightness = 0.7},
	{ frame = 70, procName = "image_setBrightness", id = "onigiri", brightness = 0.8},
	{ frame = 80, procName = "image_setBrightness", id = "onigiri", brightness = 0.9},
	{ frame = 90, procName = "image_setBrightness", id = "onigiri", brightness = 1.0},


	{ frame = 80, procName = "image_show", id = "onigiri_light1"},
	{ frame = 85, procName = "image_show", id = "onigiri_light2"},
	{ frame = 90, procName = "image_show", id = "onigiri_light3"},
	
	{ frame = 85, procName = "image_hide", id = "onigiri_light1"},
	{ frame = 90, procName = "image_hide", id = "onigiri_light2"},
	{ frame = 95, procName = "image_hide", id = "onigiri_light3"},

	{ frame = 100, procName = "image_show", id = "onigiri_reflect1"},
	{ frame = 104, procName = "image_show", id = "onigiri_reflect2"},
	{ frame = 108, procName = "image_show", id = "onigiri_reflect3"},
	{ frame = 112, procName = "image_show", id = "onigiri_reflect2"},
	{ frame = 116, procName = "image_show", id = "onigiri_reflect1"},

	{ frame = 104, procName = "image_hide", id = "onigiri_reflect1"},
	{ frame = 108, procName = "image_hide", id = "onigiri_reflect2"},
	{ frame = 112, procName = "image_hide", id = "onigiri_reflect3"},
	{ frame = 116, procName = "image_hide", id = "onigiri_reflect2"},
	{ frame = 120, procName = "image_hide", id = "onigiri_reflect1"},

	{ frame = 104, procName = "image_setAngle", id = "onigiri_reflect1", angle = 10},
	{ frame = 104, procName = "image_setAngle", id = "onigiri_reflect2", angle = 10},
	{ frame = 104, procName = "image_setAngle", id = "onigiri_reflect3", angle = 10},
	{ frame = 108, procName = "image_setAngle", id = "onigiri_reflect1", angle = 20},
	{ frame = 108, procName = "image_setAngle", id = "onigiri_reflect2", angle = 20},
	{ frame = 108, procName = "image_setAngle", id = "onigiri_reflect3", angle = 20},
	{ frame = 112, procName = "image_setAngle", id = "onigiri_reflect1", angle = 30},
	{ frame = 112, procName = "image_setAngle", id = "onigiri_reflect2", angle = 30},
	{ frame = 112, procName = "image_setAngle", id = "onigiri_reflect3", angle = 30},
	{ frame = 116, procName = "image_setAngle", id = "onigiri_reflect1", angle = 40},
	{ frame = 116, procName = "image_setAngle", id = "onigiri_reflect2", angle = 40},
	{ frame = 116, procName = "image_setAngle", id = "onigiri_reflect3", angle = 40},
	{ frame = 120, procName = "image_setAngle", id = "onigiri_reflect1", angle = 50},
	{ frame = 120, procName = "image_setAngle", id = "onigiri_reflect2", angle = 50},
	{ frame = 120, procName = "image_setAngle", id = "onigiri_reflect3", angle = 50},


	{ frame = 1, text = "人類は精一杯の科学力で地球に残された僅かな資源を結集し、", procName = "registText", id = "speak1"},
	{ frame = 1, text = "古来より伝わる客人をもてなすための祝祭食の形で自分たちの思念を具現化した。", procName = "registText", id = "speak2"},

	{ frame =   1, procName = "text_show", id = "speak1"},
	{ frame = 160, procName = "text_hide", id = "speak1"},
	{ frame = 170, procName = "text_show", id = "speak2"},
	{ frame = 480, procName = "text_hide", id = "speak2"},
	
	{ frame =  320, procName = "nextPage", scriptName = "storyDemoOP7"},
	
}


scripts["storyDemoOP7"] = {
	
	{ frame = 1, procName = "registFont", id = "default", file = "PixelMplus10-Regular.ttf", size = 20},
	{ frame = 1, procName = "text_setDefaultSettings", x = 200, y=430, displayWait = 1, lineLength=20, fontId="default"},

	{ frame = 1, procName = "registSound", id = "opening"},
	{ frame = 1, procName = "sound_play", id = "opening"},


	{ frame = 1, procName = "setBackgroundColor", r = 0.5, g = 0.5, b = 0.8, a = 1},

	{ frame = 1, procName = "registImage", id = "universe", file = "universe.png"},
	{ frame = 1, procName = "registImage", id = "playerMachine", file = "playerMachine.png"},
	{ frame = 1, procName = "registImage", id = "earth", file = "earth.png"},
	{ frame = 1, procName = "registImage", id = "frame", file = "frame.png"},

	{ frame = 1, procName = "image_show", id = "frame"},
	{ frame = 1, procName = "image_show", id = "playerMachine"},

	{ frame = 300, procName = "image_show", id = "universe"},
	{ frame = 300, procName = "image_show", id = "earth"},

	{ frame = 300, procName = "image_setScale", id = "playerMachine", scaleW = 0.01, scaleH = 0.02},
	{ frame = 300, procName = "image_setAngle", id = "playerMachine", angle = -70},
	{ frame = 300, procName = "image_setPosition", id = "playerMachine", x = 400, y = 300},
	{ frame = 300, procName = "image_move", id = "playerMachine", toX = 180, toY = 200, speed = 2},

	{ frame = 1, procName = "image_setPosition", id = "playerMachine", x = 400, y = 300},

	{ frame = 1, text = "それを空間に射出することのみに特化した宇宙艇「ZEN-e-o」を建造し、", procName = "registText", id = "speak1"},
	{ frame = 1, text = "人類の命運を託された一人の若きパイロットが、", procName = "registText", id = "speak2"},
	{ frame = 1, text = "接近する未知の生命体を迎えるべく、宇宙に飛び立った。", procName = "registText", id = "speak3"},

	{ frame =   1, procName = "text_show", id = "speak1"},
	{ frame = 160, procName = "text_hide", id = "speak1"},
	{ frame = 170, procName = "text_show", id = "speak2"},
	{ frame = 300, procName = "text_hide", id = "speak2"},
	{ frame = 310, procName = "text_show", id = "speak3"},
--	{ frame = 520, procName = "text_hide", id = "speak3"},
	
	--{ frame = 450, procName = "endDemo"},
	{ frame = 300, procName = "sound_fadeout", id = "opening", pace=0.02},
	{ frame = 480, procName = "nextPage", scriptName = "storyDemo0"},
	

	{ frame = 10, procName = "image_setScale", id = "playerMachine", scaleW = 0.9, scaleH = 0.9},
	{ frame = 15, procName = "image_setScale", id = "playerMachine", scaleW = 0.8, scaleH = 0.8},
	{ frame = 20, procName = "image_setScale", id = "playerMachine", scaleW = 0.7, scaleH = 0.7},
	{ frame = 25, procName = "image_setScale", id = "playerMachine", scaleW = 0.6, scaleH = 0.6},
	{ frame = 30, procName = "image_setScale", id = "playerMachine", scaleW = 0.5, scaleH = 0.5},
	{ frame = 35, procName = "image_setScale", id = "playerMachine", scaleW = 0.4, scaleH = 0.4},
	{ frame = 40, procName = "image_setScale", id = "playerMachine", scaleW = 0.3, scaleH = 0.3},
	{ frame = 45, procName = "image_setScale", id = "playerMachine", scaleW = 0.2, scaleH = 0.2},
	{ frame = 50, procName = "image_setScale", id = "playerMachine", scaleW = 0.1, scaleH = 0.1},
	{ frame = 55, procName = "image_setScale", id = "playerMachine", scaleW = 0.05, scaleH = 0.05},

	{ frame = 200, procName = "image_move", id = "playerMachine", toX = 400, toY = -50, speed = 3},

	
}

scripts["storyDemo0"] = {

	{ frame = 1, procName = "draw_setTranslate", translateX = 0, translateY = -30 },

	
	{ frame = 1, procName = "registImage", id = "female",          file = "storyDemo_female.png"},
	{ frame = 1, procName = "registImage", id = "female_speak",    file = "storyDemo_female_speak.png"},
	{ frame = 1, procName = "registImage", id = "background1",     file = "storyDemo_background1.png"},
	{ frame = 1, procName = "registImage", id = "background2",     file = "storyDemo_background2.png"},
	{ frame = 1, procName = "registImage", id = "monitor_filter1", file = "storyDemo_monitorFilter1.png"},
	{ frame = 1, procName = "registImage", id = "monitor_filter2", file = "storyDemo_monitorFilter2.png"},

	{ frame = 1, procName = "registSound", id = "connection",          file = "オフ＿消灯.wav", type="static"},
	{ frame = 1, procName = "sound_play", id = "connection"},

	{ frame = 1, procName = "registImage", id = "noise1",          file = "monitor_noise1.png"},
	{ frame = 1, procName = "registImage", id = "noise2",          file = "monitor_noise2.png"},

	{ frame = 1, procName = "image_show", id = "noise1"},
	{ frame = 5, procName = "image_show", id = "noise2"},
	{ frame = 10, procName = "image_hide", id = "noise2"},
	{ frame = 15, procName = "image_show", id = "noise2"},
	{ frame = 20, procName = "image_hide", id = "noise2"},
	{ frame = 25, procName = "image_show", id = "noise2"},
	{ frame = 30, procName = "image_hide", id = "noise2"},
	{ frame = 35, procName = "image_hide", id = "noise1"},
	
	{ frame = 1, procName = "image_show", id = "background1"},
	{ frame = 1, procName = "image_show", id = "female"},
	{ frame = 1, procName = "image_show", id = "monitor_filter1"},
	
	{ frame = 1, procName = "registFont", id = "default", file = "PixelMplus10-Regular.ttf", size = 20},
	
	{ frame = 1, procName = "registText", id = "speak1", fontId = "default", lineLength = 20, text = "Z型の印がついているキーで「おにぎり」を射出できるわ。"},
	{ frame = 1, procName = "registText", id = "speak2", fontId = "default", lineLength = 20, text = "私たち人類の総意。精一杯の善意よ。"},
	{ frame = 1, procName = "registText", id = "speak3", fontId = "default", lineLength = 20, text = "残念だけど、機体のエネルギーは長くはもたないわ。"},
	{ frame = 1, procName = "registText", id = "speak4", fontId = "default", lineLength = 20, text = "こちらの善意が通じれば、あるいは……。"},

	{ frame = 1, procName = "text_setPosition", id = "speak1", x = 200, y = 510},
	{ frame = 1, procName = "text_setPosition", id = "speak2", x = 200, y = 510},
	{ frame = 1, procName = "text_setPosition", id = "speak3", x = 200, y = 510},
	{ frame = 1, procName = "text_setPosition", id = "speak4", x = 200, y = 510},
	
	{ frame = 1, procName = "text_setDisplayWait", id = "speak1", displayWait = 4},
	{ frame = 1, procName = "text_setDisplayWait", id = "speak2", displayWait = 4},
	{ frame = 1, procName = "text_setDisplayWait", id = "speak3", displayWait = 4},
	{ frame = 1, procName = "text_setDisplayWait", id = "speak4", displayWait = 4},



	{ frame =  10, procName = "text_show", id = "speak1"},
		{ frame = 1, procName = "registRepeatProc", id = "speakAnime1", repeatWait = 20, proc = { procName = "image_show", id = "female_speak"}},
		{ frame = 10, procName = "registRepeatProc", id = "speakAnime2", repeatWait = 20, proc = { procName = "image_hide", id = "female_speak"}},
		{ frame = 160, procName = "deleteRepeatProc", id = "speakAnime1" },
		{ frame = 160, procName = "deleteRepeatProc", id = "speakAnime2" },
		{ frame = 160, procName = "image_hide", id = "female_speak"},
	{ frame = 200, procName = "text_hide", id = "speak1"},
	
	
	{ frame = 210, procName = "text_show", id = "speak2"},
		{ frame = 200, procName = "registRepeatProc", id = "speakAnime1", repeatWait = 20, proc = { procName = "image_show", id = "female_speak"}},
		{ frame = 210, procName = "registRepeatProc", id = "speakAnime2", repeatWait = 20, proc = { procName = "image_hide", id = "female_speak"}},
		{ frame = 300, procName = "deleteRepeatProc", id = "speakAnime1" },
		{ frame = 300, procName = "deleteRepeatProc", id = "speakAnime2" },
		{ frame = 300, procName = "image_hide", id = "female_speak"},
	{ frame = 400, procName = "text_hide", id = "speak2"},

	{ frame = 410, procName = "text_show", id = "speak3"},
		{ frame = 400, procName = "registRepeatProc", id = "speakAnime1", repeatWait = 20, proc = { procName = "image_show", id = "female_speak"}},
		{ frame = 410, procName = "registRepeatProc", id = "speakAnime2", repeatWait = 20, proc = { procName = "image_hide", id = "female_speak"}},
		{ frame = 540, procName = "deleteRepeatProc", id = "speakAnime1" },
		{ frame = 540, procName = "deleteRepeatProc", id = "speakAnime2" },
		{ frame = 540, procName = "image_hide", id = "female_speak"},
	{ frame = 600, procName = "text_hide", id = "speak3"},

	{ frame = 610, procName = "text_show", id = "speak4"},
		{ frame = 600, procName = "registRepeatProc", id = "speakAnime1", repeatWait = 20, proc = { procName = "image_show", id = "female_speak"}},
		{ frame = 610, procName = "registRepeatProc", id = "speakAnime2", repeatWait = 20, proc = { procName = "image_hide", id = "female_speak"}},
		{ frame = 730, procName = "deleteRepeatProc", id = "speakAnime1" },
		{ frame = 730, procName = "deleteRepeatProc", id = "speakAnime2" },
		{ frame = 730, procName = "image_hide", id = "female_speak"},
	{ frame = 800, procName = "text_hide", id = "speak4"},

	{ frame = 810, procName = "endDemo"},
	
	{ frame = 1, procName = "registRepeatProc", id = "backgroundAnime1", repeatWait = 60, proc = { procName = "image_show", id = "background2"} },
	{ frame = 31, procName = "registRepeatProc", id = "backgroundAnime2", repeatWait = 60, proc = { procName = "image_hide", id = "background2"} },

	{ frame = 1, procName = "registRepeatProc", id = "monitorAnime1-1", repeatWait = 10, proc = { procName = "image_show", id = "monitor_filter2"} },
	{ frame = 1, procName = "registRepeatProc", id = "monitorAnime1-2", repeatWait = 10, proc = { procName = "image_hide", id = "monitor_filter1"} },
	{ frame = 6, procName = "registRepeatProc", id = "monitorAnime2-1", repeatWait = 10, proc = { procName = "image_show", id = "monitor_filter1"} },
	{ frame = 6, procName = "registRepeatProc", id = "monitorAnime2-2", repeatWait = 10, proc = { procName = "image_hide", id = "monitor_filter2"} },

}

scripts["storyDemo1"] = {
	
	{ frame = 1, procName = "draw_setTranslate", translateX = 0, translateY = -30 },

	
	{ frame = 1, procName = "registImage", id = "male",          file = "storyDemo_male.png"},
	{ frame = 1, procName = "registImage", id = "male_speak",    file = "storyDemo_male_speak.png"},
	{ frame = 1, procName = "registImage", id = "background1",     file = "storyDemo_background1.png"},
	{ frame = 1, procName = "registImage", id = "background2",     file = "storyDemo_background2.png"},
	{ frame = 1, procName = "registImage", id = "monitor_filter1", file = "storyDemo_monitorFilter1.png"},
	{ frame = 1, procName = "registImage", id = "monitor_filter2", file = "storyDemo_monitorFilter2.png"},


	{ frame = 1, procName = "registSound", id = "connection",          file = "オフ＿消灯.wav", type="static"},
	{ frame = 1, procName = "sound_play", id = "connection"},

	{ frame = 1, procName = "registImage", id = "noise1",          file = "monitor_noise1.png"},
	{ frame = 1, procName = "registImage", id = "noise2",          file = "monitor_noise2.png"},

	{ frame = 1, procName = "image_show", id = "noise1"},
	{ frame = 5, procName = "image_show", id = "noise2"},
	{ frame = 10, procName = "image_hide", id = "noise2"},
	{ frame = 15, procName = "image_show", id = "noise2"},
	{ frame = 20, procName = "image_hide", id = "noise2"},
	{ frame = 25, procName = "image_show", id = "noise2"},
	{ frame = 30, procName = "image_hide", id = "noise2"},
	{ frame = 35, procName = "image_hide", id = "noise1"},
	

	{ frame = 1, procName = "image_show", id = "background1"},
	{ frame = 1, procName = "image_show", id = "male"},
	{ frame = 1, procName = "image_show", id = "monitor_filter1"},
	
	{ frame = 1, procName = "registFont", id = "default", file = "PixelMplus10-Regular.ttf", size = 20},
	{ frame = 1, procName = "registText", id = "speak", fontId = "default", lineLength = 20, text = "おにぎりが嫌いなやつだっている。"},
	{ frame = 1, procName = "text_setPosition", id = "speak", x = 200, y = 510},
	{ frame = 1, procName = "text_setDisplayWait", id = "speak", displayWait = 4},
	{ frame = 60, procName = "text_show", id = "speak"},
	
	{ frame = 1, procName = "registRepeatProc", id = "backgroundAnime1", repeatWait = 60, proc = { procName = "image_show", id = "background2"} },
	{ frame = 31, procName = "registRepeatProc", id = "backgroundAnime2", repeatWait = 60, proc = { procName = "image_hide", id = "background2"} },

	{ frame = 1, procName = "registRepeatProc", id = "monitorAnime1-1", repeatWait = 10, proc = { procName = "image_show", id = "monitor_filter2"} },
	{ frame = 1, procName = "registRepeatProc", id = "monitorAnime1-2", repeatWait = 10, proc = { procName = "image_hide", id = "monitor_filter1"} },
	{ frame = 6, procName = "registRepeatProc", id = "monitorAnime2-1", repeatWait = 10, proc = { procName = "image_show", id = "monitor_filter1"} },
	{ frame = 6, procName = "registRepeatProc", id = "monitorAnime2-2", repeatWait = 10, proc = { procName = "image_hide", id = "monitor_filter2"} },

	{ frame = 60, procName = "image_show", id = "male_speak"},
	{ frame = 70, procName = "image_hide", id = "male_speak"},
	{ frame = 80, procName = "image_show", id = "male_speak"},
	{ frame = 90, procName = "image_hide", id = "male_speak"},
	{ frame = 100, procName = "image_show", id = "male_speak"},
	{ frame = 110, procName = "image_hide", id = "male_speak"},
	{ frame = 120, procName = "image_show", id = "male_speak"},
	{ frame = 130, procName = "image_hide", id = "male_speak"},
	
	{ frame = 170, procName = "endDemo"},

}

scripts["storyDemo2"] = {
	
	{ frame = 1, procName = "draw_setTranslate", translateX = 0, translateY = -30 },
	
	{ frame = 1, procName = "registImage", id = "female",          file = "storyDemo_female.png"},
	{ frame = 1, procName = "registImage", id = "female_speak",    file = "storyDemo_female_speak.png"},
	{ frame = 1, procName = "registImage", id = "background1",     file = "storyDemo_background1.png"},
	{ frame = 1, procName = "registImage", id = "background2",     file = "storyDemo_background2.png"},
	{ frame = 1, procName = "registImage", id = "monitor_filter1", file = "storyDemo_monitorFilter1.png"},
	{ frame = 1, procName = "registImage", id = "monitor_filter2", file = "storyDemo_monitorFilter2.png"},


	{ frame = 1, procName = "registSound", id = "connection",          file = "オフ＿消灯.wav", type="static"},
	{ frame = 1, procName = "sound_play", id = "connection"},

	{ frame = 1, procName = "registImage", id = "noise1",          file = "monitor_noise1.png"},
	{ frame = 1, procName = "registImage", id = "noise2",          file = "monitor_noise2.png"},

	{ frame = 1, procName = "image_show", id = "noise1"},
	{ frame = 5, procName = "image_show", id = "noise2"},
	{ frame = 10, procName = "image_hide", id = "noise2"},
	{ frame = 15, procName = "image_show", id = "noise2"},
	{ frame = 20, procName = "image_hide", id = "noise2"},
	{ frame = 25, procName = "image_show", id = "noise2"},
	{ frame = 30, procName = "image_hide", id = "noise2"},
	{ frame = 35, procName = "image_hide", id = "noise1"},
	
	

	{ frame = 1, procName = "image_show", id = "background1"},
	{ frame = 1, procName = "image_show", id = "female"},
	{ frame = 1, procName = "image_show", id = "monitor_filter1"},
	
	{ frame = 1, procName = "registFont", id = "default", file = "PixelMplus10-Regular.ttf", size = 20},
	{ frame = 1, procName = "registText", id = "speak", fontId = "default", lineLength = 20, text = "なかまどうしで争っているばあいじゃないわ。"},
	{ frame = 1, procName = "text_setPosition", id = "speak", x = 200, y = 510},
	{ frame = 1, procName = "text_setDisplayWait", id = "speak", displayWait = 4},
	{ frame = 60, procName = "text_show", id = "speak"},
	
	{ frame = 1, procName = "registRepeatProc", id = "backgroundAnime1", repeatWait = 60, proc = { procName = "image_show", id = "background2"} },
	{ frame = 31, procName = "registRepeatProc", id = "backgroundAnime2", repeatWait = 60, proc = { procName = "image_hide", id = "background2"} },

	{ frame = 1, procName = "registRepeatProc", id = "monitorAnime1-1", repeatWait = 10, proc = { procName = "image_show", id = "monitor_filter2"} },
	{ frame = 1, procName = "registRepeatProc", id = "monitorAnime1-2", repeatWait = 10, proc = { procName = "image_hide", id = "monitor_filter1"} },
	{ frame = 6, procName = "registRepeatProc", id = "monitorAnime2-1", repeatWait = 10, proc = { procName = "image_show", id = "monitor_filter1"} },
	{ frame = 6, procName = "registRepeatProc", id = "monitorAnime2-2", repeatWait = 10, proc = { procName = "image_hide", id = "monitor_filter2"} },

	{ frame = 60, procName = "image_show", id = "female_speak"},
	{ frame = 70, procName = "image_hide", id = "female_speak"},
	{ frame = 80, procName = "image_show", id = "female_speak"},
	{ frame = 90, procName = "image_hide", id = "female_speak"},
	{ frame = 100, procName = "image_show", id = "female_speak"},
	{ frame = 110, procName = "image_hide", id = "female_speak"},
	{ frame = 120, procName = "image_show", id = "female_speak"},
	{ frame = 130, procName = "image_hide", id = "female_speak"},
	{ frame = 140, procName = "image_show", id = "female_speak"},
	{ frame = 150, procName = "image_hide", id = "female_speak"},
	
	{ frame = 210, procName = "endDemo"},

}

scripts["storyDemo3"] = {
	
	{ frame = 1, procName = "draw_setTranslate", translateX = 0, translateY = -30 },
	
	{ frame = 1, procName = "registImage", id = "male",          file = "storyDemo_male.png"},
	{ frame = 1, procName = "registImage", id = "male_speak",    file = "storyDemo_male_speak.png"},
	{ frame = 1, procName = "registImage", id = "background1",     file = "storyDemo_background1.png"},
	{ frame = 1, procName = "registImage", id = "background2",     file = "storyDemo_background2.png"},
	{ frame = 1, procName = "registImage", id = "monitor_filter1", file = "storyDemo_monitorFilter1.png"},
	{ frame = 1, procName = "registImage", id = "monitor_filter2", file = "storyDemo_monitorFilter2.png"},

	{ frame = 1, procName = "registSound", id = "connection",          file = "オフ＿消灯.wav", type="static"},
	{ frame = 1, procName = "sound_play", id = "connection"},

	{ frame = 1, procName = "registImage", id = "noise1",          file = "monitor_noise1.png"},
	{ frame = 1, procName = "registImage", id = "noise2",          file = "monitor_noise2.png"},

	{ frame = 1, procName = "image_show", id = "noise1"},
	{ frame = 5, procName = "image_show", id = "noise2"},
	{ frame = 10, procName = "image_hide", id = "noise2"},
	{ frame = 15, procName = "image_show", id = "noise2"},
	{ frame = 20, procName = "image_hide", id = "noise2"},
	{ frame = 25, procName = "image_show", id = "noise2"},
	{ frame = 30, procName = "image_hide", id = "noise2"},
	{ frame = 35, procName = "image_hide", id = "noise1"},

	{ frame = 1, procName = "image_show", id = "background1"},
	{ frame = 1, procName = "image_show", id = "male"},
	{ frame = 1, procName = "image_show", id = "monitor_filter1"},
	
	{ frame = 1, procName = "registFont", id = "default", file = "PixelMplus10-Regular.ttf", size = 20},
	{ frame = 1, procName = "registText", id = "speak", fontId = "default", lineLength = 20, text = "やつらは「未知」だ。どうにもならない。"},
	{ frame = 1, procName = "text_setPosition", id = "speak", x = 200, y = 510},
	{ frame = 1, procName = "text_setDisplayWait", id = "speak", displayWait = 4},
	{ frame = 60, procName = "text_show", id = "speak"},
	
	{ frame = 1, procName = "registRepeatProc", id = "backgroundAnime1", repeatWait = 60, proc = { procName = "image_show", id = "background2"} },
	{ frame = 31, procName = "registRepeatProc", id = "backgroundAnime2", repeatWait = 60, proc = { procName = "image_hide", id = "background2"} },

	{ frame = 1, procName = "registRepeatProc", id = "monitorAnime1-1", repeatWait = 10, proc = { procName = "image_show", id = "monitor_filter2"} },
	{ frame = 1, procName = "registRepeatProc", id = "monitorAnime1-2", repeatWait = 10, proc = { procName = "image_hide", id = "monitor_filter1"} },
	{ frame = 6, procName = "registRepeatProc", id = "monitorAnime2-1", repeatWait = 10, proc = { procName = "image_show", id = "monitor_filter1"} },
	{ frame = 6, procName = "registRepeatProc", id = "monitorAnime2-2", repeatWait = 10, proc = { procName = "image_hide", id = "monitor_filter2"} },

	{ frame = 60, procName = "image_show", id = "male_speak"},
	{ frame = 70, procName = "image_hide", id = "male_speak"},
	{ frame = 80, procName = "image_show", id = "male_speak"},
	{ frame = 90, procName = "image_hide", id = "male_speak"},
	{ frame = 100, procName = "image_show", id = "male_speak"},
	{ frame = 110, procName = "image_hide", id = "male_speak"},
	{ frame = 120, procName = "image_show", id = "male_speak"},
	{ frame = 130, procName = "image_hide", id = "male_speak"},
	
	{ frame = 180, procName = "endDemo"},

}

scripts["storyDemo4"] = {
	
	{ frame = 1, procName = "draw_setTranslate", translateX = 0, translateY = -30 },
	
	{ frame = 1, procName = "registImage", id = "female",          file = "storyDemo_female.png"},
	{ frame = 1, procName = "registImage", id = "female_speak",    file = "storyDemo_female_speak.png"},
	{ frame = 1, procName = "registImage", id = "background1",     file = "storyDemo_background1.png"},
	{ frame = 1, procName = "registImage", id = "background2",     file = "storyDemo_background2.png"},
	{ frame = 1, procName = "registImage", id = "monitor_filter1", file = "storyDemo_monitorFilter1.png"},
	{ frame = 1, procName = "registImage", id = "monitor_filter2", file = "storyDemo_monitorFilter2.png"},

	{ frame = 1, procName = "registSound", id = "connection",          file = "オフ＿消灯.wav", type="static"},
	{ frame = 1, procName = "sound_play", id = "connection"},

	{ frame = 1, procName = "registImage", id = "noise1",          file = "monitor_noise1.png"},
	{ frame = 1, procName = "registImage", id = "noise2",          file = "monitor_noise2.png"},

	{ frame = 1, procName = "image_show", id = "noise1"},
	{ frame = 5, procName = "image_show", id = "noise2"},
	{ frame = 10, procName = "image_hide", id = "noise2"},
	{ frame = 15, procName = "image_show", id = "noise2"},
	{ frame = 20, procName = "image_hide", id = "noise2"},
	{ frame = 25, procName = "image_show", id = "noise2"},
	{ frame = 30, procName = "image_hide", id = "noise2"},
	{ frame = 35, procName = "image_hide", id = "noise1"},

	{ frame = 1, procName = "image_show", id = "background1"},
	{ frame = 1, procName = "image_show", id = "female"},
	{ frame = 1, procName = "image_show", id = "monitor_filter1"},
	
	{ frame = 1, procName = "registFont", id = "default", file = "PixelMplus10-Regular.ttf", size = 20},
	{ frame = 1, procName = "registText", id = "speak", fontId = "default", lineLength = 20, text = "私たちは私たちの「最善を尽くす」しかないのよ。"},
	{ frame = 1, procName = "text_setPosition", id = "speak", x = 200, y = 510},
	{ frame = 1, procName = "text_setDisplayWait", id = "speak", displayWait = 4},
	{ frame = 60, procName = "text_show", id = "speak"},
	
	{ frame = 1, procName = "registRepeatProc", id = "backgroundAnime1", repeatWait = 60, proc = { procName = "image_show", id = "background2"} },
	{ frame = 31, procName = "registRepeatProc", id = "backgroundAnime2", repeatWait = 60, proc = { procName = "image_hide", id = "background2"} },

	{ frame = 1, procName = "registRepeatProc", id = "monitorAnime1-1", repeatWait = 10, proc = { procName = "image_show", id = "monitor_filter2"} },
	{ frame = 1, procName = "registRepeatProc", id = "monitorAnime1-2", repeatWait = 10, proc = { procName = "image_hide", id = "monitor_filter1"} },
	{ frame = 6, procName = "registRepeatProc", id = "monitorAnime2-1", repeatWait = 10, proc = { procName = "image_show", id = "monitor_filter1"} },
	{ frame = 6, procName = "registRepeatProc", id = "monitorAnime2-2", repeatWait = 10, proc = { procName = "image_hide", id = "monitor_filter2"} },

	{ frame = 60, procName = "image_show", id = "female_speak"},
	{ frame = 70, procName = "image_hide", id = "female_speak"},
	{ frame = 80, procName = "image_show", id = "female_speak"},
	{ frame = 90, procName = "image_hide", id = "female_speak"},
	{ frame = 100, procName = "image_show", id = "female_speak"},
	{ frame = 110, procName = "image_hide", id = "female_speak"},
	{ frame = 120, procName = "image_show", id = "female_speak"},
	{ frame = 130, procName = "image_hide", id = "female_speak"},
	{ frame = 140, procName = "image_show", id = "female_speak"},
	{ frame = 150, procName = "image_hide", id = "female_speak"},
	
	{ frame = 210, procName = "endDemo"},

}

scripts["storyDemoED1"] = {
	
	{ frame = 1, procName = "registFont", id = "default", file = "PixelMplus10-Regular.ttf", size = 20},
	{ frame = 1, procName = "registImage", id = "universe", file = "universe.png"},
	{ frame = 1, procName = "registImage", id = "unknown", file = "unknown.png"},
	{ frame = 1, procName = "registImage", id = "playerMachine", file = "playerMachine.png"},
	{ frame = 1, procName = "registImage", id = "unknown_gulpCover", file = "unknown_gulpCover.png"},

	{ frame = 1, procName = "registImage", id = "white", file = "white.png"},
	{ frame = 1, procName = "registImage", id = "frame", file = "frame.png"},
	
	{ frame = 1, procName = "registSound", id = "end_story"},
	{ frame = 1, procName = "sound_play", id = "end_story"},
	{ frame = 1, procName = "sound_setLoop", id = "end_story"},

	{ frame = 1, procName = "image_setPosition", id = "universe", x = 400, y = 100},
	{ frame = 1, procName = "image_move", id = "universe", toX = 400, toY = 400, speed = 0.2},


	{ frame = 1, procName = "image_setScale", id = "playerMachine", scaleW = 0.02},
	{ frame = 1, procName = "image_setPosition", id = "playerMachine", x = 400, y = 410},
	{ frame = 1, procName = "image_move", id = "playerMachine", toX = 400, toY = 350, speed = 0.5},

	
	{ frame = 1, procName = "image_show", id = "frame"},
	{ frame = 1, procName = "image_show", id = "universe"},
	{ frame = 1, procName = "image_show", id = "playerMachine"},

	-- 女性キャラセリフへ
	{ frame = 120, procName = "image_hide", id = "universe"},
	{ frame = 120, procName = "image_hide", id = "frame"},
	{ frame = 120, procName = "image_hide", id = "playerMachine"},
	
	{ frame = 120, procName = "draw_setTranslate", translateX = 0, translateY = -30 },

	{ frame = 1, procName = "registImage", id = "female",          file = "storyDemo_female.png"},
	{ frame = 1, procName = "registImage", id = "female_speak",    file = "storyDemo_female_speak.png"},
	{ frame = 1, procName = "registImage", id = "male",            file = "storyDemo_male.png"},
	{ frame = 1, procName = "registImage", id = "male_speak",      file = "storyDemo_male_speak.png"},
	{ frame = 1, procName = "registImage", id = "background1",     file = "storyDemo_background1.png"},
	{ frame = 1, procName = "registImage", id = "background2",     file = "storyDemo_background2.png"},
	{ frame = 1, procName = "registImage", id = "monitor_filter1", file = "storyDemo_monitorFilter1.png"},
	{ frame = 1, procName = "registImage", id = "monitor_filter2", file = "storyDemo_monitorFilter2.png"},

	{ frame = 121, procName = "registRepeatProc", id = "monitorAnime1-1", repeatWait = 10, proc = { procName = "image_show", id = "monitor_filter2"} },
	{ frame = 121, procName = "registRepeatProc", id = "monitorAnime1-2", repeatWait = 10, proc = { procName = "image_hide", id = "monitor_filter1"} },
	{ frame = 126, procName = "registRepeatProc", id = "monitorAnime2-1", repeatWait = 10, proc = { procName = "image_show", id = "monitor_filter1"} },
	{ frame = 126, procName = "registRepeatProc", id = "monitorAnime2-2", repeatWait = 10, proc = { procName = "image_hide", id = "monitor_filter2"} },

	{ frame = 130, procName = "image_show", id = "female_speak"},
	{ frame = 140, procName = "image_hide", id = "female_speak"},
	{ frame = 150, procName = "image_show", id = "female_speak"},
	{ frame = 160, procName = "image_hide", id = "female_speak"},
	{ frame = 170, procName = "image_show", id = "female_speak"},

	{ frame = 120, procName = "image_show", id = "background1"},
	{ frame = 120, procName = "image_show", id = "female"},
	{ frame = 120, procName = "image_show", id = "monitor_filter1"},

	{ frame = 1, procName = "registText", id = "speak_female", fontId = "default", lineLength = 20, text = "あ、あれは……！"},
	{ frame = 1, procName = "text_setPosition", id = "speak_female", x = 200, y = 510},
	{ frame = 1, procName = "text_setDisplayWait", id = "speak_female", displayWait = 4},
	{ frame = 120, procName = "text_show", id = "speak_female"},
	
	-- 宇宙シーン再開へ
	{ frame = 200, procName = "draw_setTranslate", translateX = 0, translateY = 0 },
	{ frame = 200, procName = "image_hide", id = "background1"},
	{ frame = 200, procName = "image_hide", id = "female"},
	{ frame = 200, procName = "image_hide", id = "female_speak"},
	{ frame = 200, procName = "image_hide", id = "monitor_filter1"},
	{ frame = 200, procName = "image_hide", id = "monitor_filter2"},
	{ frame = 200, procName = "text_hide", id = "speak_female"},

	{ frame = 200, procName = "deleteRepeatProc", id = "monitorAnime1-1"},
	{ frame = 200, procName = "deleteRepeatProc", id = "monitorAnime1-2"},
	{ frame = 200, procName = "deleteRepeatProc", id = "monitorAnime2-1"},
	{ frame = 200, procName = "deleteRepeatProc", id = "monitorAnime2-2"},
	
	{ frame = 200, procName = "image_show", id = "frame"},
	{ frame = 200, procName = "image_show", id = "universe"},
	{ frame = 200, procName = "image_show", id = "playerMachine"},
	
	-- 巨大な「未知」出現
	{ frame = 1, procName = "image_setPosition", id = "unknown", x = 400, y = -100},
	{ frame = 200, procName = "image_show", id = "unknown"},
	{ frame = 200, procName = "image_move", id = "unknown", toX = 400, toY = 300, speed = 1},
	
	-- 男性キャラ発言
	{ frame = 300, procName = "image_hide", id = "universe"},
	{ frame = 300, procName = "image_hide", id = "frame"},
	{ frame = 300, procName = "image_hide", id = "playerMachine"},
	{ frame = 300, procName = "image_hide", id = "unknown"},
	{ frame = 300, procName = "draw_setTranslate", translateX = 0, translateY = -30 },

	{ frame = 300, procName = "registRepeatProc", id = "monitorAnime1-1", repeatWait = 10, proc = { procName = "image_show", id = "monitor_filter2"} },
	{ frame = 300, procName = "registRepeatProc", id = "monitorAnime1-2", repeatWait = 10, proc = { procName = "image_hide", id = "monitor_filter1"} },
	{ frame = 305, procName = "registRepeatProc", id = "monitorAnime2-1", repeatWait = 10, proc = { procName = "image_show", id = "monitor_filter1"} },
	{ frame = 305, procName = "registRepeatProc", id = "monitorAnime2-2", repeatWait = 10, proc = { procName = "image_hide", id = "monitor_filter2"} },

	{ frame = 310, procName = "image_show", id = "male_speak"},
	{ frame = 320, procName = "image_hide", id = "male_speak"},
	{ frame = 330, procName = "image_show", id = "male_speak"},
	{ frame = 340, procName = "image_hide", id = "male_speak"},
	{ frame = 350, procName = "image_show", id = "male_speak"},
	{ frame = 360, procName = "image_hide", id = "male_speak"},

	{ frame = 300, procName = "image_show", id = "background1"},
	{ frame = 300, procName = "image_show", id = "male"},
	{ frame = 300, procName = "image_show", id = "monitor_filter1"},

	{ frame = 1, procName = "registText", id = "speak_male", fontId = "default", lineLength = 20, text = "……圧倒的だな。"},
	{ frame = 1, procName = "text_setPosition", id = "speak_male", x = 200, y = 510},
	{ frame = 1, procName = "text_setDisplayWait", id = "speak_male", displayWait = 4},
	{ frame = 300, procName = "text_show", id = "speak_male"},


	-- 宇宙シーン再開へ
	{ frame = 400, procName = "image_hide", id = "background1"},
	{ frame = 400, procName = "image_hide", id = "male"},
	{ frame = 400, procName = "image_hide", id = "male_speak"},
	{ frame = 400, procName = "image_hide", id = "monitor_filter1"},
	{ frame = 400, procName = "image_hide", id = "monitor_filter2"},
	{ frame = 400, procName = "text_hide", id = "speak_male"},
	{ frame = 400, procName = "draw_setTranslate", translateX = 0, translateY = 0 },
	

	{ frame = 400, procName = "deleteRepeatProc", id = "monitorAnime1-1"},
	{ frame = 400, procName = "deleteRepeatProc", id = "monitorAnime1-2"},
	{ frame = 400, procName = "deleteRepeatProc", id = "monitorAnime2-1"},
	{ frame = 400, procName = "deleteRepeatProc", id = "monitorAnime2-2"},

	{ frame = 400, procName = "image_show", id = "frame"},
	{ frame = 400, procName = "image_show", id = "universe"},
	{ frame = 400, procName = "image_show", id = "playerMachine"},
	{ frame = 400, procName = "image_show", id = "unknown"},

	{ frame = 400, procName = "image_setPosition", id = "unknown_gulpCover", otherImage="unknown"},
	{ frame = 400, procName = "image_show", id = "unknown_gulpCover"},
	{ frame = 400, procName = "image_move", id = "unknown_gulpCover", toX = 400, toY = 300, speed = 1},
	
	{ frame = 520, procName = "image_show", id = "white" },
	{ frame = 520, procName = "image_setAlpha", id = "white", alpha = 0.1 },
	{ frame = 525, procName = "image_setAlpha", id = "white", alpha = 0.2 },
	{ frame = 530, procName = "image_setAlpha", id = "white", alpha = 0.3 },
	{ frame = 535, procName = "image_setAlpha", id = "white", alpha = 0.4 },
	{ frame = 540, procName = "image_setAlpha", id = "white", alpha = 0.5 },
	{ frame = 545, procName = "image_setAlpha", id = "white", alpha = 0.6 },
	{ frame = 550, procName = "image_setAlpha", id = "white", alpha = 0.7 },
	{ frame = 555, procName = "image_setAlpha", id = "white", alpha = 0.8 },
	{ frame = 560, procName = "image_setAlpha", id = "white", alpha = 0.9 },
	{ frame = 565, procName = "image_setAlpha", id = "white", alpha = 1.0 },
	
	{ frame =  600, procName = "nextPage", scriptName = "storyDemoED2"},
	
}


scripts["storyDemoED2"] = {

	{ frame = 1, procName = "registFont", id = "default", file = "PixelMplus10-Regular.ttf", size = 20},
	{ frame = 1, procName = "text_setDefaultSettings", x = 200, y=430, displayWait = 1, lineLength=20, fontId="default"},

	{ frame = 1, procName = "registText", id = "speak1", text = "E N D"},
	{ frame = 1, procName = "text_setDisplayWait", id = "speak1", displayWait=10},
	{ frame = 1, procName = "text_setPosition", id = "speak1", x = 370, y = 430},
	{ frame = 100, procName = "text_show", id = "speak1"},
	
	{ frame = 500, procName = "text_hide", id = "speak1"},
	{ frame = 500, procName = "custom", func = 
		function(self)
			print("カスタム処理")
			local refText = self:getText("speak1")
			local white = self:getImage("white_pseudo")
			white.textObj = { 
				text = refText.text,
				--x = self.defaultSettings_text.x, y = self.defaultSettings_text.y
				x = refText.x, y = refText.y
			}
		end
	},
	
	
	{ frame = 1, procName = "registImage", id = "universe", file = "universe.png"},
	{ frame = 1, procName = "registImage", id = "unknown", file = "unknown.png"},
	{ frame = 1, procName = "registImage", id = "earth", file = "earth.png"},
	{ frame = 1, procName = "registImage", id = "unknown_gulpCover", file = "unknown_gulpCover.png"},

	{ frame = 1, procName = "registImage", id = "white", file = "white.png"},
	{ frame = 1, procName = "registImage", id = "frame", file = "frame.png"},

	{ frame = 1, procName = "registImage", id = "unknown_biggest", file = "unknown_biggest.png"},
	{ frame = 1, procName = "registImage", id = "white_pseudo", file = "white.png"},
	{ frame = 1, procName = "registImage", id = "unknown_biggest_gulpCover", file = "unknown_biggest_gulpCover.png"},

	{ frame = 1, procName = "registImage", id = "white_outer", file = "white.png"},

	{ frame = 1, procName = "image_setScale", id = "white_pseudo", scaleW=0.5, scaleH=0.5},


	{ frame = 1, procName = "image_setPosition", id = "earth", x = 400, y = 350},
	{ frame = 1, procName = "image_setPosition", id = "earth", x = 400, y = 350},
	{ frame = 1, procName = "image_show", id = "frame"},
	{ frame = 1, procName = "image_show", id = "universe"},
	{ frame = 1, procName = "image_show", id = "earth"},

	{ frame = 1, procName = "image_setPosition", id = "unknown", x = 400, y = -200},
	{ frame = 1, procName = "image_setPosition", id = "unknown_gulpCover", otherImage = "unknown"},
	{ frame = 1, procName = "image_show", id = "unknown"},
	{ frame = 1, procName = "image_show", id = "unknown_gulpCover"},

	{ frame = 1, procName = "image_move", id = "unknown", toX = 400, toY = 300, speed = 1},
	{ frame = 1, procName = "image_move", id = "unknown_gulpCover", toX = 400, toY = 300, speed = 1},

	{ frame = 1, procName = "image_move", id = "universe", toX = 400, toY = 1, speed = 0.05},
	{ frame = 1, procName = "image_move", id = "earth",    toX = 400, toY = 1, speed = 0.1},

	{ frame = 400, procName = "image_show", id = "white" },
	{ frame = 400, procName = "image_setAlpha", id = "white", alpha = 0.1 },
	{ frame = 405, procName = "image_setAlpha", id = "white", alpha = 0.2 },
	{ frame = 410, procName = "image_setAlpha", id = "white", alpha = 0.3 },
	{ frame = 415, procName = "image_setAlpha", id = "white", alpha = 0.4 },
	{ frame = 420, procName = "image_setAlpha", id = "white", alpha = 0.5 },
	{ frame = 425, procName = "image_setAlpha", id = "white", alpha = 0.6 },
	{ frame = 430, procName = "image_setAlpha", id = "white", alpha = 0.7 },
	{ frame = 435, procName = "image_setAlpha", id = "white", alpha = 0.8 },
	{ frame = 440, procName = "image_setAlpha", id = "white", alpha = 0.9 },
	{ frame = 445, procName = "image_setAlpha", id = "white", alpha = 1.0 },

	{ frame = 200, procName = "image_setPosition", id = "white_pseudo", x = 400, y = 250},
	{ frame = 500, procName = "image_show", id = "white_pseudo"},

	{ frame = 1, procName = "image_setPosition", id = "unknown_biggest", x = 400, y = -620},
	{ frame = 1, procName = "image_setPosition", id = "unknown_biggest_gulpCover", otherImage="unknown_biggest"},
	{ frame = 1, procName = "image_show", id = "unknown_biggest"},
	{ frame = 1, procName = "image_show", id = "unknown_biggest_gulpCover"},

	{ frame = 520, procName = "image_move", id = "unknown_biggest", toX = 400, toY = 640, speed = 3},
	{ frame = 520, procName = "image_move", id = "unknown_biggest_gulpCover", toX = 400, toY = 640, speed = 3},

	--{ frame = 420, procName = "image_setScale", id = "unknown_biggest", scaleW = 0.5, scaleH=0.5},


	{ frame = 900, procName = "image_show", id = "white_outer" },
	{ frame = 900, procName = "image_setAlpha", id = "white_outer", alpha = 0.1 },
	{ frame = 905, procName = "image_setAlpha", id = "white_outer", alpha = 0.2 },
	{ frame = 910, procName = "image_setAlpha", id = "white_outer", alpha = 0.3 },
	{ frame = 915, procName = "image_setAlpha", id = "white_outer", alpha = 0.4 },
	{ frame = 920, procName = "image_setAlpha", id = "white_outer", alpha = 0.5 },
	{ frame = 925, procName = "image_setAlpha", id = "white_outer", alpha = 0.6 },
	{ frame = 930, procName = "image_setAlpha", id = "white_outer", alpha = 0.7 },
	{ frame = 935, procName = "image_setAlpha", id = "white_outer", alpha = 0.8 },
	{ frame = 940, procName = "image_setAlpha", id = "white_outer", alpha = 0.9 },
	{ frame = 945, procName = "image_setAlpha", id = "white_outer", alpha = 1.0 },
		
	--{ frame =  400, procName = "nextPage", scriptName = "storyDemoED3"},
	
	{ frame = 1200, procName = "endDemo"},
}


scripts["storyDemo_challengeEND"] = {
	
	{ frame = 1, procName = "draw_setTranslate", translateX = 0, translateY = 20 },
	
	{ frame = 1, procName = "registFont", id = "default", file = "PixelMplus10-Regular.ttf", size = 20},
	{ frame = 1, procName = "text_setDefaultSettings", x = 200, y=430, displayWait = 5, lineLength=20, fontId="default"},

	{ frame = 1, procName = "registImage", id = "cg", file = "challengeModeEND.png"},
	{ frame = 1, procName = "registImage", id = "frame",     file = "frame.png"},
	
	{ frame = 1, procName = "registSound", id = "end_challenge"},
	{ frame = 1, procName = "sound_play", id = "end_challenge"},
	{ frame = 1, procName = "sound_setLoop", id = "end_challenge"},

	{ frame = 1, procName = "image_setBrightness", id = "cg", brightness=0},
	{ frame = 30, procName = "image_setBrightness", id = "cg", brightness=0.2},
	{ frame = 60, procName = "image_setBrightness", id = "cg", brightness=0.4},
	{ frame = 90, procName = "image_setBrightness", id = "cg", brightness=0.6},
	{ frame = 120, procName = "image_setBrightness", id = "cg", brightness=0.8},
	{ frame = 150, procName = "image_setBrightness", id = "cg", brightness=1.0},

	{ frame = 1, procName = "image_show", id = "cg"},
	{ frame = 1, procName = "image_show", id = "frame"},
	
	{ frame = 1, procName = "image_setPosition", id = "cg", x = 400, y = 200},
	
	{ frame = 1, procName = "registText", id = "speak1", fontId = "default", lineLength = 999, text = "CONGRATULATIONS!!"},
	{ frame = 1, procName = "registText", id = "speak2", fontId = "default", lineLength = 999, text = "THANK YOU FOR PLAYING!!"},
	{ frame = 1, procName = "text_setPosition", id = "speak1", x = 320, y = 60},
	{ frame = 1, procName = "text_setPosition", id = "speak2", x = 300, y = 380},

	{ frame =  60, procName = "text_show", id = "speak1"},
	{ frame =  200, procName = "text_show", id = "speak2"},
	
	{ frame = 500, procName = "endDemo"},
	
}


scripts["test"] = {
	
	{ frame = 1, procName = "registFont", id = "default", file = "PixelMplus10-Regular.ttf", size = 30},
	{ frame = 1, procName = "text_setDefaultSettings", x = 150, y=560, displayWait = 5, lineLength=20, fontId="default"},

	{ frame = 1, procName = "registSound", id = "clear"},

	{ frame = 1, procName = "registImage", id = "yama", file = "山道＿nc280527.jpg"},
	{ frame = 1, procName = "registImage", id = "ten",  file = "天の光＿nc280228.jpg"},
	{ frame = 1, procName = "registImage", id = "mari", file = "mari_normal_1.png"},
	{ frame = 1, procName = "registImage", id = "yui",  file = "yui_surprise.png"},
	{ frame = 1, procName = "registImage", id = "zunda", file = "ずんだ＿nc283465.png"},
	{ frame = 1, procName = "registImage", id = "textWindow", file = "textWindow.png"},

	{ frame = 1, procName = "image_setPosition", id = "textWindow", x = 400, y = 575},
	{ frame = 1, procName = "image_show", id = "textWindow"},

	{ frame = 1, procName = "image_setScale", id = "yama", scaleW = 0.5, scaleH = 0.5},
	{ frame = 1, procName = "image_setScale", id = "ten", scaleW = 0.5, scaleH = 0.5},
	{ frame = 1, procName = "image_setScale", id = "mari", scaleW = 0.6, scaleH = 0.6},
	{ frame = 1, procName = "image_setScale", id = "yui", scaleW = 0.6, scaleH = 0.6},

	{ frame = 1, procName = "image_show", id = "yama"},

	{ frame = 60, procName = "image_setPosition", id = "mari", x = 700, y = 500},
	{ frame = 60, procName = "image_show", id = "mari"},

	{ frame = 80, procName = "registText", id = "text1", fontId = "default", text = "おや、あそこにいるのは……。"},
	{ frame = 80, procName = "text_show", id = "text1"},

	{ frame = 180, procName = "image_move", id = "mari", toX = 550, toY = 500, speed = 10},

	{ frame = 240, procName = "text_hide", id = "text1"},
	{ frame = 240, procName = "image_setPosition", id = "yui", x = 300, y = 500},
	{ frame = 240, procName = "image_show", id = "yui"},

	{ frame = 300, procName = "registText", id = "text2", fontId = "default", text = "ユイさん、こんなところで一体何を？"},
	{ frame = 300, procName = "text_show", id = "text2"},

	{ frame = 420, procName = "text_hide", id = "text2"},
	{ frame = 420, procName = "registText", id = "text3", fontId = "default", text = "お腹がすいて、気がついたらこんなところに……。"},
	{ frame = 420, procName = "text_show", id = "text3"},

	{ frame = 600, procName = "text_hide", id = "text3"},
	{ frame = 600, procName = "registText", id = "text4", fontId = "default", text = "あっ？！"},
	{ frame = 600, procName = "text_show", id = "text4"},

	{ frame = 600, procName = "image_show", id = "ten"},
	{ frame = 600, procName = "image_setPosition", id = "zunda", x = 400, y = 100},
	{ frame = 600, procName = "image_show", id = "zunda"},
	
	{ frame = 700, procName = "image_move", id = "zunda", toX = 400, toY = 500, speed = 2},
	
	{ frame = 900, procName = "sound_play", id = "clear"},
	
	{ frame = 900, procName = "text_hide", id = "text4"},
	{ frame = 900, procName = "registText", id = "text5", fontId = "default", text = "なんと、天からずんだ餅が！"},
	{ frame = 900, procName = "text_show", id = "text5"},

	{ frame = 1000, procName = "endDemo"},
}

return scripts

